#include<avr/io.h>
#include<avr/interrupt.h>
#include<stdio.h>
#include<stdint.h>
#include"serial.h"


#define false 0
#define true 1

typedef unsigned char bool;
typedef unsigned char uchar;


#define SIN 0
#define SOUT 1
#define SCLK 2

#define SPORT PORTC
#define SPIN  PINC
#define SDDR  DDRC

volatile int ticks;
uchar buffer[640];
uchar text[32];
volatile int wait_val;

char tab[16]={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};

char * itoh(int val,char *tb)
{
char *p;
p=tb;
*p=tab[(val>>4)&0x0f];
p++;
*p=tab[val&0x0f];
p++;
*p='\0';
return tb;
}

void init_timer()
{
	TCCR2=(1<<WGM21)|(1<<CS21);
	OCR2=0x06;
	TIMSK=(1<<OCIE2);
}


void wait_ms(int val)
{

/*

	cli();
	ticks=0;
	sei();
	while(ticks<val){}
	cli();
*/

int c;
for(c=0;c<val*5;c++)
{}



}

void init_port(void)
{
	SDDR=(1<<SOUT);
	SPORT=(1<<SCLK);
	DDRB=0xff;
}

uchar transmit(uchar data)
{
	uchar temp=0;

	int c;

	
		
	for(c=7;c>-1;c--)
	{
	


	if((data&(1<<c))==0){PORTC&=~(1<<SOUT);PORTB=0x00;}else{PORTC|=(1<<SOUT);PORTB=0x01;}
	PORTC&=~(1<<SCLK);
	DDRC&=~(1<<SCLK);
		

	asm("nop");
	
	wait_ms(3);		
	
	
	DDRC|=(1<<SCLK);
	PORTC|=(1<<SCLK);
	
	wait_ms(3);	
	if((PORTC&(1<<SIN))!=0){temp|=(1<<c);}	

	}



	wait_ms(10);

	
	return temp;
}


int send_data(uchar command,uchar *data,int len)
{
uchar retl,reth;
int sum;

PORTC&=~(1<<SOUT);

	asm("nop");	

	DDRC|=(1<<SCLK);
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");	



sum=0;
transmit(0x88);
transmit(0x33);
transmit(command);
sum+=(command);

transmit(0x00);

transmit(len&0xff);
sum+=(len&0xff);

transmit((len>>8)&0xff);
sum+=((len>>8)&0xff);

int c;

for(c=0;c<len;c++)
{
transmit(*(data+c));
sum+=(*(data+c));
}

transmit(sum&0xff);
transmit((sum>>8)&0xff);

reth=transmit(0x00);
retl=transmit(0x00);


USART_puts("CMD:");
USART_puts(itoh(command,text));
USART_puts(" ");

USART_puts("LEN:");
USART_puts(itoh(len>>8,text));
USART_puts(itoh(len,text));
USART_puts(" ");

USART_puts("CHKSUM:");
USART_puts(itoh(sum>>8,text));
USART_puts(itoh(sum,text));
USART_puts(" ");

USART_puts("ACK:");
USART_puts(itoh(reth,text));
USART_puts(itoh(retl,text));
USART_puts("\n");


return reth;

}




uchar print[4]={0x01,0x13,0xE4,0x40};

int main(void)
{
	init_timer();
	init_port();
	USART_init(207);
	USART_puts("GB - Printer\n");
		
	int c;
	for(c=0;c<640;c++)
	{
		buffer[c]=0xAA;
	}

	

	
	
	 
    send_data(0x01,NULL,0);
	send_data(0x04,buffer,640);
	send_data(0x04,NULL,0);
	send_data(0x02,print,4);
	USART_puts("Data sent\n");



	while(1)
	{

	}

	return 0;
}




ISR(SIG_OUTPUT_COMPARE2) 
{
ticks++;
}
